% This program does  modified criminisi exemplar inpainting
function[img1,img2,img3,img4,img5] = genetic_criminisi_2(fillRegion,img,ind,ind2,ind2_test,w,I_S,sz,pop_size)

%% Initialize values
fillRegion_o=fillRegion;
ind_o=ind;
img_o=img;
for pop=1:pop_size
    fillRegion=fillRegion_o;
    sourceRegion=~fillRegion;
    ind=ind_o;
    img=img_o;
    row_no=0;
    L=zeros(I_S);
    C = double(sourceRegion);
    D = repmat(-.1,sz);    %Creates a matrix of size sz with values -.1
    img_test=img;
    dR_g=zeros(I_S);
    dR_g=uint8(dR_g);

  while any(fillRegion(:)) %fillRegion(:) returns the fillRegion in column vector form
    row_no=row_no+1;
    
    %% Find contour & normalized gradients of fill region
    dR = find(conv2(double(fillRegion),[1,1,1;1,-8,1;1,1,1],'same')>0); %returns the boundary of fillRegion
    dR_g(dR)=img_test(dR);
    dR_g=double(dR_g);

    [I,Ix,Iy]=my_gradient(img,fillRegion);
    temp = Ix; Ix = -Iy; Iy = temp;  % Rotate gradient 90 degrees in clockwise direction
    Ix2=Ix;Iy2=Iy;
    [N,Nx,Ny] = my_normal(img,fillRegion);
    temp = Nx; Nx = -Ny; Ny = temp;
    [m n]=size(Nx);
    for i=1:m
      for j=1:n
          N(i,j)=sqrt(Nx(i,j)^2+Ny(i,j)^2);
      end
    end
    
    %% Compute confidences along the fill front
    for k=dR'
      r=k;
      %For each Patch Hp on fill boundary, calculate confidence term
      k=k-1; y=floor(k/sz(1))+1; k=rem(k,sz(1)); x=floor(k)+1;%sz(1) ) p (
      rows = max(x-w,1):min(x+w,sz(1));
      cols = (max(y-w,1):min(y+w,sz(2)))';
      X = rows(ones(length(cols),1),:);
      Y = cols(:,ones(1,length(rows)));
      Hp = X+(Y-1)*sz(1);
      %q = Hp(~(fillRegion(Hp)));% q will contain only source region pixels or location values in a column vector
      q = Hp(sourceRegion(Hp));% q will contain only source region pixels or location values in a column vector
      C(r) =sum(C(q))/numel(Hp);
      Lx(r) = (sum(abs(Ix(q)))/numel(Hp));
      Ly(r) = (sum(abs(Iy(q)))/numel(Hp));
      L(r)=2+(Lx(r)+Ly(r));
    end
    
    %% Compute data term and patch priorities = confidence term * data term
    D(dR) =abs((Ix(dR).*Nx(dR)+Iy(dR).*Ny(dR))./N(dR))/255+ 0.001;

    priorities=C(dR).* D(dR).*L(dR);
  
    %% Find patch with maximum priority, Hp
    if pop==1
        [unused,ndx] = max(priorities(:));
    else
        [unused,ndx]=sort(priorities(:),'descend');
    end
    p = dR(ndx(pop));  % Central pixel of patch with max priority  %% pop
    %p = dR(ndx(1));  % Central pixel of patch with max priority
    t=p;
    p_matrix(row_no,1)=p;
    
    p=p-1; y=floor(p/sz(1))+1; p=rem(p,sz(1)); x=floor(p)+1;
    rows = max(x-w,1):min(x+w,sz(1));
    cols = (max(y-w,1):min(y+w,sz(2)))';
    X = rows(ones(length(cols),1),:);
    Y = cols(:,ones(1,length(rows)));
    Hp = X+(Y-1)*sz(1);
    %Hp = get_patch(p,sz,w);  %% This function not working, but it should.
    [m,n]=size(Hp);
    
    p_matrix(row_no,2)=m;
    p_matrix(row_no,3)=n;
    
    img_test(Hp)=255;
    img_test(Hp+I_S*I_S)=255;
    img_test(Hp+I_S*I_S*2)=255;
    %figure;imshow(uint8(img_test));title('patch to be inpainted');
    toFill = fillRegion(Hp);

    %% Find exemplar that minimizes error, Hq
    m=size(img(rows,cols,:),1); mm=size(img,1); n=size(img(rows,cols,:),2); nn=size(img,2);
    %best = three_best_error(mm,nn,m,n,img,img(rows,cols,:),toFill',sourceRegion);
    best = five_best_error(mm,nn,m,n,img,img(rows,cols,:),toFill',sourceRegion);
    s_cost(row_no,1)=best(21)/numel(Hp);
    s_cost(row_no,2)=best(22)/numel(Hp);
    s_cost(row_no,3)=best(23)/numel(Hp);
    s_cost(row_no,4)=best(24)/numel(Hp);
    s_cost(row_no,5)=best(25)/numel(Hp);
    %Hq = sub2ndx(best(1):best(2),(best(3):best(4))',mm);
    rows_1=best(1):(best(2));cols_1=(best(3):(best(4)))';
    X = rows_1(ones(length(cols_1),1),:);
    Y = cols_1(:,ones(1,length(rows_1)));
    Hq = X+(Y-1)*mm;
    
    img_test(Hq)=0;
    img_test(Hq+I_S*I_S)=0;
    img_test(Hq+I_S*I_S*2)=255;

    rows_2=best(5):best(6);cols_2=(best(7):best(8))';
    X2 = rows_2(ones(length(cols_2),1),:);
    Y2 = cols_2(:,ones(1,length(rows_2)));
    Hq2 = X2+(Y2-1)*mm;
  
    img_test(Hq2)=0;
    img_test(Hq2+I_S*I_S)=0;
    img_test(Hq2+I_S*I_S*2)=255;
    
    rows_3=best(9):best(10);cols_3=(best(11):best(12))';
    X3 = rows_3(ones(length(cols_3),1),:);
    Y3 = cols_3(:,ones(1,length(rows_3)));
    Hq3 = X3+(Y3-1)*mm;
  
    img_test(Hq3)=0;
    img_test(Hq3+I_S*I_S)=0;
    img_test(Hq3+I_S*I_S*2)=255;
    
    rows_4=best(13):best(14);cols_4=(best(15):best(16))';
    X4 = rows_4(ones(length(cols_4),1),:);
    Y4 = cols_4(:,ones(1,length(rows_4)));
    Hq4 = X4+(Y4-1)*mm;
    
    rows_5=best(17):best(18);cols_5=(best(19):best(20))';
    X5 = rows_5(ones(length(cols_5),1),:);
    Y5 = cols_5(:,ones(1,length(rows_5)));
    Hq5 = X5+(Y5-1)*mm;
        
    S_P(row_no,1)=Hq(1,1);
    S_P(row_no,2)=Hq2(1,1);
    S_P(row_no,3)=Hq3(1,1);
    S_P(row_no,4)=Hq4(1,1);
    S_P(row_no,5)=Hq5(1,1);

    %% Update fill region
    fillRegion_matrix(:,:,row_no)=fillRegion;
    fillRegion(Hp(toFill)) = false;
  
    %% Propagate confidence & isophote values
    C(Hp(toFill))  = C(t);

    %% Copy image data from Hq to Hp
    ind_matrix(:,:,row_no)=ind;
    ind2_matrix(:,:,row_no)=ind2;
    ind2_test_matrix(:,:,row_no)=ind2_test;
  
    ind(Hp(toFill)) = ind(Hq(toFill));
    ind2(Hp(toFill)) = ind2(Hq2(toFill));
    ind2_test(Hp(toFill)) =1;
   
    img_patch=zeros(size(rows,2),size(cols,1));
    for i=3:-1:1
      temp=img(:,:,i);
      img_patch(:,:,i)=temp(ind(rows,cols));
    end
    img(rows,cols,:)=img_patch;
  
    img2_patch=zeros(size(rows,2),size(cols,1));
    for i=3:-1:1
      temp2=img(:,:,i);
      img2_patch(:,:,i)=temp2(ind2(rows,cols));
    end
    img_2(rows,cols,:)=img2_patch;
  
    img2_test_patch=zeros(size(rows,2),size(cols,1));
    for i=3:-1:1
      temp2=img(:,:,i);
      img2_test_patch(:,:,i)=temp2(ind2_test(rows,cols));
    end
    img2_test(rows,cols,:)=img2_test_patch;
  
    img_test=img;
    
    clear priorities;
  end

  qualityscore  = brisquescore(img);
  text(1,3,['qualityscore=', num2str(qualityscore)] ,'FontSize',8,'Color','yellow','FontWeight','bold');
  eval(['img' num2str(pop) '= img;']);
end